

#include <stdio.h>
#include <rpc/rpc.h>
#include "../ahhead.h"
#include "stdhed.h"

char	*progname;

main(argc,argv)		/* filter:  ah -> std format			*/
			/* returns:	0	->	OK		*/
int	argc;		/*		-1	->	usage err 	*/
char	**argv;		/*		-2	->	too much data 	*/
			/*		-3	->	alloc failed	*/
{				/*	--witte		11 june 85	*/

	char		*aptr,*calloc(),*mkdatspace(),*strcpy();
	int		i,end,sw;
	ahhed		ahhead;
	XDR		xdr_in;
	stdhed		stdhead;

	progname= argv[0];

	if(out_is_tty() || in_is_tty())
	{
		fprintf(stderr,"Usage -- %s <input >output\n",progname);
		exit(-1);
	}

	xdrstdio_create(&xdr_in, stdin, XDR_DECODE);

/*	get ah header and map -> std header	*/

	while(xdr_gethead(&ahhead, &xdr_in) > 0)
	{
		stdhead.iblk = BUFSIZ;
		if(ahhead.record.ndata > 32767L)
		{
			fprintf(stderr,"%s:  too much data for std\n",progname);
			exit(-2);
		}
		stdhead.ndata= ahhead.record.ndata;
		switch(ahhead.record.type)
		{
		case VECTOR:
		case TENSOR:
		case 5:
			++(ahhead.record.type);
		case FLOAT:
		case COMPLEX:
			stdhead.ivar= ahhead.record.type;
			break;
		}	/*	end switch(ahhead.record.type)	*/
		stdhead.samp= ahhead.record.delta;
		stdhead.tmin= ahhead.record.rmin;
		stdhead.tmax= stdhead.tmin + (stdhead.samp)*(stdhead.ndata);
		strcpy(ahhead.record.rcomment,stdhead.title);
		strcpy(ahhead.station.code,stdhead.scode);
		strcpy(ahhead.station.chan,stdhead.comp);
		stdhead.itime.day= ahhead.record.abstime.day;
		stdhead.itime.month= ahhead.record.abstime.mo;
		stdhead.itime.year= ahhead.record.abstime.yr;
		stdhead.itime.hour= ahhead.record.abstime.hr;
		stdhead.itime.minutes= ahhead.record.abstime.mn;
		stdhead.itime.tenths= 10.*(ahhead.record.abstime.sec);

		stdhead.jtime.day= ahhead.event.ot.day;
		stdhead.jtime.month= ahhead.event.ot.mo;
		stdhead.jtime.year= ahhead.event.ot.yr;
		stdhead.jtime.hour= ahhead.event.ot.hr;
		stdhead.jtime.minutes= ahhead.event.ot.mn;
		stdhead.jtime.tenths= 10.*(ahhead.event.ot.sec);

		stdhead.evlat= ahhead.event.lat;
		stdhead.evlon= ahhead.event.lon;
		stdhead.evdep= ahhead.event.dep;

		for(i=0; i<NEXTRAS; ++i)
			stdhead.extra[i]= ahhead.extra[i];

		for(i=NEXTRAS; i<24; ++i)
			stdhead.extra[i]= 0.;

/*	NOW HANDLE DATA	*/

		aptr= mkdatspace(&ahhead);

		(aptr != NULL) ? (sw= 0) : (sw= 1);

		switch(sw)
		{
		case 0:		/* lots of space	*/
/*	write	stdhead	*/
			fwrite((char *)&stdhead,sizeof(char),STDHEADSIZE,stdout);
			xdr_getdata(&ahhead,(char *)aptr, &xdr_in);
/*	write data	*/
			fwrite((char *)aptr,size(&ahhead),(int)ahhead.record.ndata,stdout);
			break;

		case 1:		/* chop into blocks	*/
			if((aptr= calloc((unsigned)BUFSIZ,(unsigned)size(&ahhead))) == NULL)
			{
				fprintf(stderr,"%s:  not enough room\n",progname);
				exit(-3);
			}

/*	write stdhead	*/
			fwrite((char *)&stdhead,sizeof(char),STDHEADSIZE,stdout);

			end= ahhead.record.ndata/BUFSIZ;	/* # whole blocks */
			for(i=0; i<end; ++i)
			{
				fread(aptr,size(&ahhead),BUFSIZ,stdin);
				fwrite(aptr,size(&ahhead),BUFSIZ,stdout);
			}

			end= ahhead.record.ndata%BUFSIZ;	/* remainder	*/
			fread(aptr,size(&ahhead),end,stdin);
			fwrite(aptr,size(&ahhead),end,stdout);

			break;
		}	/*	end switch(sw)	*/

		cfree(aptr);

	}	/*	end while(getdata)	*/
	xdr_destroy(&xdr_in);
	exit(0);
}	/*	end main	*/
