#include <stdio.h>
#include <rpc/rpc.h>
#include "../ahhead.h"

char *progname="ah2xdr";	/* converts sun ah data file to xdr format */

main(argc, argv)
int argc;
char *argv[];
{
	filter(stdin, stdout);
}


filter(file_in, file_out)
FILE *file_in, *file_out;
{
	ahhed h;
	XDR xdrs;
	int gethead(), getdata(), xdr_putrecord();
	char *data, *mkdatspace();
	long i;

	xdrstdio_create(&xdrs, file_out, XDR_ENCODE);
	while (gethead( &h, file_in ) == 1) {
		data = mkdatspace(&h);
		if(data == (char *) NULL) {
			fprintf(stderr, "%s: memory allocation error\n", progname);
			exit(-1);
		}
		if(getdata(&h, data, file_in) == -1) {
			fprintf(stderr, "%s: data read error\n");
			exit(-1);
		}
		if(xdr_putrecord(&h, data, &xdrs) != 0) {
			fprintf(stderr, "%s: data write error\n");
			exit(-1);
		}

		free(data);
	}
	xdr_destroy(&xdrs);
}
