#include	"trim.h"

/*  structure for waveform index info  */

struct	wfdisc	{
long	date;
double	time;
char	sta[8];
char	chan[4];
long	nsamp;
float	smprat;
float	calib;
float	calper;
char	instyp[8];
char	segtyp[4];
char	dattyp[4];
char	clip[4];
long	chid;
long	wfid;
char	dir[32];
char	file[24];
long	foff;
long	adate;
char	remark[32];
}; 

#define WFDISC___A "%D%lf%*c%6c%*c%2c%D%f%f%f%*c%6c%*c%c%*c%2c%*c%c%D%D%*c
#define WFDISC_RCS WFDISC___A/**/%30c%*c%20c%D%D%*c%30c"

#define WFDISC_RVL(SP) \
&(SP)->date,&(SP)->time,(SP)->sta,(SP)->chan,&(SP)->nsamp,\
&(SP)->smprat,&(SP)->calib,&(SP)->calper,(SP)->instyp,(SP)->segtyp,\
(SP)->dattyp,(SP)->clip,&(SP)->chid,&(SP)->wfid,(SP)->dir,\
(SP)->file,&(SP)->foff,&(SP)->adate,(SP)->remark

#define WFDISC___B "%8D %15.3lf %-6.6s %-2.2s %8D %11.7f %9.6f %7.4f
#define WFDISC___C WFDISC___B %-6.6s %1s %-2.2s %1s %8D %8D %-30.30s
#define WFDISC_WCS WFDISC___C %-20.20s %10D %8D %-30.30s\n"

#define WFDISC_WVL(SP) \
(SP)->date,(SP)->time,(SP)->sta,(SP)->chan,\
(SP)->nsamp,(SP)->smprat,(SP)->calib,(SP)->calper,\
(SP)->instyp,(SP)->segtyp,(SP)->dattyp,(SP)->clip,(SP)->chid,\
(SP)->wfid,(SP)->dir,(SP)->file,(SP)->foff,\
(SP)->adate,(SP)->remark

#define WFDISC_TRM(SP) \
TRIM((SP)->sta,7); TRIM((SP)->chan,3); TRIM((SP)->instyp,7); \
TRIM((SP)->segtyp,2); TRIM((SP)->dattyp,3); TRIM((SP)->clip,2); \
TRIM((SP)->dir,31); TRIM((SP)->file,21); TRIM((SP)->remark,31)

#define WFDISC_FPD(SP) \
FPAD((SP)->sta,8); FPAD((SP)->chan,4); FPAD((SP)->instyp,8); \
FPAD((SP)->segtyp,4); FPAD((SP)->dattyp,4); FPAD((SP)->clip,4); \
FPAD((SP)->dir,32); FPAD((SP)->file,24); FPAD((SP)->remark,32)

#define WFDISC_BFL(SP) \
BFIL((SP)->sta,8); BFIL((SP)->chan,4); BFIL((SP)->instyp,8); \
BFIL((SP)->segtyp,4); BFIL((SP)->dattyp,4); BFIL((SP)->clip,4); \
BFIL((SP)->dir,32); BFIL((SP)->file,24); BFIL((SP)->remark,32)

static struct wfdisc wfdisc_null = {
-1,			/* date */
-9999999999.999,	/* time */
"_",			/* sta */
"_",			/* chan */
-1,			/* nsamp */
-1.,			/* smprat */
0.,			/* calib */
-1.,			/* calper */
"_",			/* instyp */
"_",			/* segtyp */
"_",			/* dattyp */
"_",			/* clip */
-1,			/* chid */
-1,			/* wfid */
"_",			/* dir */
"_",			/* file */
0,			/* foff NO NULL VALUE ASSIGNED */
-1,			/* adate */
"_"			/* remark */
};
