.TH FORMATS 5 "February 1989"
.SH NAME
net_formats \- description of various file formats for network processing
.SH DESCRIPTION
.LP
This manual page gives a description of various formats being used in network
processing.

\fBstation file\fR - this is a standard HYPOINVERSE format station file.
.br

\fBchannels file\fR - the channels file is an ascii file which contains information
about stations in a network.  Below is a sample gain file:
.br

.br
.nf
  1 bkjz 0 55.157 159.559 240.   41.7  1n 
  2 ivfz 0 55.896 159.530 275.   47.7  1n 
  3 dt2z 0 55.165 162.230 700.    1.0  1n 
  4 balz 0 55.193 162.787 366.   35.5  1n 
  5 drrz 0 54.924 162.283 380.   53.7  1n 
  6 dlgz 0 55.141 161.836 360.   47.7  1n 
  7 snkz 0 54.474 162.775 159.   47.5  1n 
  8 pvvz 1 55.374 161.790 180.   47.5  1n 
  9 pvvn 1 55.374 161.790 180.   43.6  1o 
 10 pvve 1 55.374 161.790 180.   41.5  1n 
 11 cnbz 2 54.820 159.588 90.    41.5  1n 
 12 ps4z 0 55.354 161.868 520.   53.4  1gc
 13 cnfz 2 54.820 159.588 90.    42.0  1f 
 14 cnfn 2 54.820 159.588 90.    42.0  1f 
 15 cnfe 2 54.820 159.588 90.    42.0  1f 
.br
.fi

The gain file contains 8 fields of information:
.br

field name              column(s)         type
.br
----------              -------           ----
.br

.nf
.br
channel number          2-3               integer
.br
station name            5-8               characters
.br
group number            10                integer 
.br
latitude                12-17             float
.br
longitude               19-25             float
.br
elevation               27-31             float
.br
recording system        40                character
.br
vco gain                33-38             float
.br
type                    40-42             characters
.br

.fi
The group number is 0 for 1 component stations.  Each multi-component station
shares a unique number with all channels of the station.


\fBresponse file\fR - the response file is an ascii file which contains
poles and zeros and some other information. Below is a sample response 
file:
.br

.br
type:	n
.br
normalization:	3630669869417392800000000000.000000
.br
system_gain:	1.33e+6 0.00e+0 1.33e+6
.br
pole.re		pole.im		zero.re		zero.im
.br
1.700000e+01	0.000000e+00	6.000000e+00	0.000000e+00
.br
-4.398230e+00	4.487090e+00	0.000000e+00	0.000000e+00
.br
-4.398230e+00	-4.487090e+00	0.000000e+00	0.000000e+00
.br
  .
.br
  .
.br
type:	o
.br
normalization:	3630669869417392800000000000.000000
.br
system gain:	5.28e+5 0.00e+0 0.00e+0
.br
pole.re		pole.im		zero.re		zero.im
.br
1.700000e+01	0.000000e+00	6.000000e+00	0.000000e+00
.br
-4.398230e+00	4.487090e+00	0.000000e+00	0.000000e+00
.br
-4.398230e+00	-4.487090e+00	0.000000e+00	0.000000e+00
.br
 .
.br
 .
.br
The colons after type, normalization and system gain are followed by a tab (this is important).
Type must be one character.  Normalization should be a floating point number.  The three
system gains (for type a, b or c seismometers respectively) are separated by spaces or a tab.
The next line contains column headings and may be changed to suit personal taste.
What follows next are 20 lines (only 3 shown here) each containing four floating point
numbers which represent the poles (real and imaginary) and zeros (real and imaginary). After the
twentieth line of poles and zeros comes the first line for the next type.
