

#include <stdio.h>
#include <rpc/rpc.h>
#include "../ahhead.h"
#include "stdhed.h"

char	*progname;

main(argc,argv)		/* filter: std -> ah */
			/*	exits:						*/
int	argc;		/*		0	->	OK			*/
char	**argv;		/*		-1	->	bad usage		*/
			/*		-2	->	1st header bad		*/
{			/*		-3	->	not enough space	*/
			/*		-4	->	unknown data type	*/
			/*		-5	->	error writing data	*/
			/*			--witte		10 june 85	*/
			/*							*/
			/*		updated to write xdr ah files		*/
			/*			--ken howard	27 sept 89	*/
			/*							*/
	char		*cptr,*strcpy(),*calloc(),*mkdatspace();
	int		*iptr,*iarray,*stop,i,end,sw;
	long		nelem;
	float		*fptr,*farray;
	ahhed		ahhead;
	XDR		xdr_out;
	stdhed		stdhead;

	progname= argv[0];
	xdrstdio_create(&xdr_out, stdout, XDR_ENCODE);

	if(out_is_tty() || in_is_tty())
	{
		fprintf(stderr,"Usage -- %s <input >output\n",progname);
		exit(-1);
	}

/* get STD header	*/

	if(fread((char *)&stdhead,sizeof(stdhed),1,stdin) != 1)
	{
		fprintf(stderr,"%s:  error reading std header\n",progname);
		exit(-2);
	}

	do	/*	loop over data sets in file	*/
	{
		/*	PUT IN DATE OF CREATION	*/

/* map stdhed -> ahhed	*/
		stdhead.title[79] = '\0';
		stdhead.scode[5] = '\0';
		stdhead.comp[3] = '\0';

		strcpy(stdhead.scode,ahhead.station.code);
		strcpy(stdhead.comp, ahhead.station.chan);
		
		ahhead.event.lat = stdhead.evlat;
		ahhead.event.lon = stdhead.evlon;
		ahhead.event.dep = stdhead.evdep;
		ahhead.event.ot.yr = stdhead.jtime.year;
		ahhead.event.ot.mo = stdhead.jtime.month;
		ahhead.event.ot.day = stdhead.jtime.day;
		ahhead.event.ot.hr = stdhead.jtime.hour;
		ahhead.event.ot.mn = stdhead.jtime.minutes;
		ahhead.event.ot.sec = (stdhead.jtime.tenths)/10.;

		ahhead.record.type = stdhead.ivar;
		ahhead.record.ndata = (long)stdhead.ndata;
		ahhead.record.delta = stdhead.samp;
		ahhead.record.rmin = stdhead.tmin;
		ahhead.record.abstime.yr = stdhead.itime.year;
		ahhead.record.abstime.mo = stdhead.itime.month;
		ahhead.record.abstime.day = stdhead.itime.day;
		ahhead.record.abstime.hr = stdhead.itime.hour;
		ahhead.record.abstime.mn = stdhead.itime.minutes;
		ahhead.record.abstime.sec = (stdhead.itime.tenths)/10.;

		strcpy(stdhead.title,ahhead.record.rcomment);

		for(i=0; i<NEXTRAS; ++i)
			ahhead.extra[i] = stdhead.extra[i];
/* NOW HANDLE DATA	*/
		switch(ahhead.record.type)
		{
		case 0:		/*	integers -> floats	*/
			++(ahhead.record.ndata);

		case 3:		/* int (x,y) -> float (x,y) */
			nelem= (long)(ahhead.record.ndata);
			if(ahhead.record.type == 3)
				nelem *= 2;

			iarray= (int *)calloc((unsigned)nelem,sizeof(int));
			farray= (float *)calloc((unsigned)nelem,sizeof(float));

			(iarray != NULL) ? ((farray != NULL) ? (sw= 0) : (sw=1)) : (sw=1);

			switch(sw)
			{
			case 0:		/* lots of space	*/
				fread((char *)iarray,sizeof(int),(int)nelem,stdin);
				stop= iarray + nelem;
				for(iptr=iarray,fptr=farray; iptr<stop; ++iptr,++fptr)
					*fptr= (float)*iptr;

				if(xdr_putrecord(&ahhead,(char *)farray, &xdr_out) != 0)
				{
					fprintf(stderr,"%s:  error writing ah record\n",progname);
					exit(-5);
				}

				break;

			case 1:		/* chop into blocks	*/
				if((iarray= (int *)calloc((unsigned)BUFSIZ,sizeof(int))) == NULL)
				{
					fprintf(stderr,"%s:  not enough room\n",progname);
					exit(-3);
				}
				if((farray= (float *)calloc((unsigned)BUFSIZ,sizeof(float))) == NULL)
				{
					fprintf(stderr,"%s:  not enough room\n",progname);
					exit(-3);
				}

				if(xdr_puthead(&ahhead, &xdr_out) != 1)
				{
					fprintf(stderr,"%s:  error writing ah header\n",progname);
					exit(-5);
				}

				end= nelem/BUFSIZ;	/* whole blocks	*/
				for(i=0; i<end; ++i)
				{
					fread((char *)iarray,sizeof(int),BUFSIZ,stdin);
					stop= iarray + BUFSIZ;
					for(iptr=iarray,fptr=farray; iptr<stop; ++iptr,++fptr)
						*fptr= (float)*iptr;
					if(!xdr_vector(&xdr_out, (char *)farray, BUFSIZ, sizeof(float), xdr_float)) 
					{
						fprintf(stderr,"%s:  error writing ah data\n",progname);
						exit(-5);
					}
				}

				end= nelem%BUFSIZ;	/* remainder	*/
				fread((char *)iarray,sizeof(int),BUFSIZ,stdin);
				stop= iarray + end;
				for(iptr=iarray,fptr=farray; iptr<stop; ++iptr,++fptr)
					*fptr= (float)*iptr;

				if(!xdr_vector(&xdr_out, (char *)farray, end, sizeof(float), xdr_float))
				{
					fprintf(stderr,"%s:  error writing ah data\n",progname);
					exit(-5);
				}

				break;
			}	/*	end switch(sw)	*/

			cfree((char *)farray);
			cfree((char *)iarray);

			break;

		case 4:		/* real (x,y) pairs	*/
		case 5:		/* x real, y complex	*/
		case 6:		/* complex (x,y) pairs	*/
			--(ahhead.record.type);

		case 1:		/* floats */
		case 2:		/* complex */
			cptr= mkdatspace(&ahhead);

			(cptr != NULL) ? (sw= 0): (sw= 1);

			switch(sw)
			{
			case 0:		/* lots of space	*/
				fread(cptr,size(&ahhead),(int)ahhead.record.ndata,stdin);

				if(xdr_putrecord(&ahhead,cptr, &xdr_out) != 0)
				{
					fprintf(stderr,"%s:  error writing ah record\n",progname);
					exit(-5);
				}

				break;

			case 1:		/* chop into BLOCKS	*/
				if((cptr= calloc((unsigned)BUFSIZ,(unsigned)size(&ahhead))) == NULL)
				{
					fprintf(stderr,"%s:  not enough room\n",progname);
					exit(-3);
				}

				if(xdr_puthead(&ahhead, &xdr_out) != 1)
				{
					fprintf(stderr,"%s:  error writing ah header\n",progname);
					exit(-5);
				}

				end= ahhead.record.ndata/BUFSIZ;	/* whole BLOCKS	*/
				for(i=0; i<end; ++i)
				{
					fread(cptr,size(&ahhead),BUFSIZ,stdin);
					if(!xdr_vector(&xdr_out, cptr, size(&ahhead)*BUFSIZ, sizeof(char), xdr_char))
					{
						fprintf(stderr,"%s:  error writing ah data\n",progname);
						exit(-5);
					}
				}

				end= ahhead.record.ndata%BUFSIZ;	/* remainder	*/
				fread(cptr,size(&ahhead),end,stdin);
				if(!xdr_vector(&xdr_out, cptr, end*size(&ahhead), sizeof(char), xdr_char))
				{
					fprintf(stderr,"%s:  error writing ah data\n",progname);
					exit(-5);
				}

				break;
			}	/*	end switch(sw)	*/

			cfree(cptr);

			break;

		default:	/*	unknown data type	*/
			fprintf(stderr,"%s:  unknown data type\n",progname);
			exit(-4);
			break;
		}		/*	end switch(ahhead.record.type)	*/
	}while(fread((char *)&stdhead,sizeof(char),STDHEADSIZE,stdin) == STDHEADSIZE);
		/*	ends loop	*/

	exit(0);
}	/*	end main	*/

			
	
